summaryrefslogtreecommitdiffstats
path: root/dansguardian
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2006-06-08 15:15:06 +0000
committer Eric Hameleers <alien@slackware.com>2006-06-08 15:15:06 +0000
commit5b1de337657457e2a82d0e12b5d7df07d923e6ea (patch)
tree14125fbd9f435a3200c79ca814d1bfa6a45bdc9a /dansguardian
parent94549ddd246a5fbf5dd59617a58c50d54b1fa5cd (diff)
downloadasb-5b1de337657457e2a82d0e12b5d7df07d923e6ea.tar.gz
asb-5b1de337657457e2a82d0e12b5d7df07d923e6ea.tar.xz
Initial revision
Diffstat (limited to 'dansguardian')
-rwxr-xr-xdansguardian/build/dansguardian.SlackBuild305
-rw-r--r--dansguardian/build/logrotate.dansguardian13
-rw-r--r--dansguardian/build/rc.dansguardian85
-rw-r--r--dansguardian/build/slack-desc19
4 files changed, 422 insertions, 0 deletions
diff --git a/dansguardian/build/dansguardian.SlackBuild b/dansguardian/build/dansguardian.SlackBuild
new file mode 100755
index 00000000..ab270ff4
--- /dev/null
+++ b/dansguardian/build/dansguardian.SlackBuild
@@ -0,0 +1,305 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
+# Distributed under the terms of the GNU General Public License, Version 2
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: dansguardian
+# Descr: web content filter
+# URL: http://dansguardian.org/
+# Needs:
+# Changelog:
+# 2.9.7.0-1: 29/mei/2006 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+# 2.9.7.1-1: 08/jun/2006 by Eric Hameleers <alien@slackware.com>
+# * Bugfix release.
+#
+# Run 'sh SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# --- INIT ---
+# Set initial variables:
+CWD=`pwd`
+if [ "$TMP" = "" ]; then
+ TMP=/tmp
+fi
+
+PRGNAM=dansguardian
+VERSION=${VERSION:-2.9.7.1}
+ARCH=${ARCH:-i486}
+BUILD=1
+
+DOCS="AUTHORS COPYING ChangeLog INSTALL NEWS README"
+
+PROXY_USR=nobody
+PROXY_GRP=nobody
+
+# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
+# If you know the URL for a source file, you can put that into the SRCURL[]
+# variable, and the SlackBuild script will try to download it for you.
+# If you set SRCUSE[] to "no" the script will never try to download or use it.
+
+SOURCE[0]="${PRGNAM}-${VERSION}.tar.gz"
+SRCURL[0]="http://usmirror.dansguardian.org/downloads/2/Alpha/${PRGNAM}-${VERSION}.tar.gz"
+SRCUSE[0]=""
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+case "$ARCH" in
+ i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ i486) SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+PKG=$TMP/package-$PRGNAM
+
+if [ ! -d $TMP/tmp-$PRGNAM ]; then
+ mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+elif [ "$1" != "--oldbuild" ]; then
+ # If the "--oldbuild" parameter is present, we keep
+ # the old build files and continue;
+ # By default we remove the remnants of previous build and continue:
+ rm -rf $TMP/tmp-$PRGNAM/*
+fi
+
+
+# --- SOURCE FILE AVAILABILITY ---
+
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${CWD}/${SOURCE[$i]} -o "${SRCUSE[$i]}" == "no" ]; then
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Source '${SOURCE[$i]}' not available yet... will download now:"
+ wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
+ if [ $? -ne 0 ]; then
+ echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
+ mv -f "${CWD}/${SOURCE[$i]}" "${CWD}/${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '${SOURCE[$i]}' not available... aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+# Safety net 8-)
+if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
+ cat <<-EOT
+ Your script sucks!!!
+ You were about to delete the contents of your computer's hard disk!
+ Please provide a value for the variable 'PKG'.
+ EOT
+ exit 1
+elif [ ! -d $PKG ]; then
+ mkdir -p $PKG # place for the package to be built
+else
+ rm -rf $PKG/* # We always erase old package's contents:
+fi
+
+cd $PKG
+
+# Explode the package framework:
+if [ -f $CWD/_$PRGNAM.tar.gz ]; then
+ explodepkg $CWD/_$PRGNAM.tar.gz
+fi
+
+cd $TMP/tmp-$PRGNAM
+
+
+# --- TARBALL EXTRACTION,PATCH,MODIFY ---
+
+echo "Extracting the source archive(s) for $PRGNAM..."
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if [ "${SRCUSE[$i]}" == "no" ]; then
+ continue
+ elif `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
+ tar -xjvf $CWD/${SOURCE[$i]}
+ elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
+ unzip $CWD/${SOURCE[$i]}
+ elif `file $CWD/${SOURCE[$i]} | grep -qi ": 7-zip"`; then
+ 7za -x $CWD/${SOURCE[$i]}
+ else
+ tar -xzvf $CWD/${SOURCE[$i]}
+ fi
+ if [ $? -ne 0 ]; then
+ echo "Error in unpacking '${SOURCE[$i]}!' Aborting..."
+ exit $?
+ fi
+done
+cd ${PRGNAM}-${VERSION}
+
+chown -R root.root *
+find . -perm 777 -exec chmod 755 {} \;
+
+
+# --- BUILDING ---
+
+echo Building ...
+
+LDFLAGS="$SLKLDFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --enable-pcre \
+ --enable-clamd \
+ --enable-email \
+ --with-proxyuser=${PROXY_USR} \
+ --with-proxygroup=${PROXY_GRP} \
+ $ARCH-slackware-linux \
+ 2>&1 | tee $CWD/configure-${PRGNAM}.log
+make 2>&1 | tee $CWD/make-${PRGNAM}.log
+
+#
+# Install all the needed stuff to the package dir
+#
+# Use installwatch if available:
+which installwatch > /dev/null 2>&1
+if [ $? == 0 ]; then
+ installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
+else
+ make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
+fi
+
+# We'll correct this in the doinst.sh
+chown root:root $PKG/var/log/dansguardian
+
+# Prepare the configuration files
+for cf in `find $PKG/etc/dansguardian -name *.conf`
+do
+ mv $cf{,.new}
+done
+
+# Install the init script
+mkdir -p $PKG/etc/rc.d
+cp $CWD/rc.dansguardian $PKG/etc/rc.d/
+chmod 644 $PKG/etc/rc.d/rc.dansguardian
+
+# Install the logrotate script
+mkdir -p $PKG/etc/logrotate.d
+cp $CWD/logrotate.dansguardian $PKG/etc/logrotate.d/dansguardian
+
+# Add this to the doinst.sh
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+# Handle the configuration files
+for cf in \`find etc/dansguardian -name *.conf.new\`
+do
+ config \$cf
+done
+
+# Fix permissions of the log directory:
+chown ${PROXY_USR}:${PROXY_GRP} var/log/dansguardian
+
+EOINS
+
+
+# --- DOCUMENTATION ---
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
+
+# Move incorrectly installed man pages, if any
+[ -d $PKG/usr/share/man ] && \
+ mv $PKG/usr/share/man $PKG/usr/ && rmdir $PKG/usr/share
+# Compress the man page(s)
+[ -d $PKG/usr/man ] && \
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+
+# Strip binaries
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+
+# --- OWNERSHIP, RIGHTS ---
+
+chmod -R o-w $PKG
+
+
+# --- PACKAGE DESCRIPTION ---
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+if [ -f $CWD/doinst.sh ]; then
+ cat $CWD/doinst.sh > $PKG/install/doinst.sh
+fi
+if [ -f $CWD/slack-required ]; then
+ cat $CWD/slack-required > $PKG/install/slack-required
+fi
+
+
+# --- BUILDING ---
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
+ 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
+(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
+fi
+
+
+# --- CLEANUP ---
+
+# Clean up the extra stuff:
+if [ "$1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi
diff --git a/dansguardian/build/logrotate.dansguardian b/dansguardian/build/logrotate.dansguardian
new file mode 100644
index 00000000..53ea537c
--- /dev/null
+++ b/dansguardian/build/logrotate.dansguardian
@@ -0,0 +1,13 @@
+/var/log/dansguardian/access.log {
+ rotate 4
+ weekly
+ sharedscripts
+ prerotate
+ /usr/sbin/dansguardian -q > /dev/null
+ sleep 5
+ endscript
+
+ postrotate
+ /usr/sbin/dansguardian > /dev/null
+ endscript
+}
diff --git a/dansguardian/build/rc.dansguardian b/dansguardian/build/rc.dansguardian
new file mode 100644
index 00000000..8d27c397
--- /dev/null
+++ b/dansguardian/build/rc.dansguardian
@@ -0,0 +1,85 @@
+#!/bin/sh
+#
+# Startup script for dansguardian
+#
+# processname: dansguardian
+# pidfile: /var/run/dansguardian.pid
+# config: /etc/dansguardian/dansguardian.conf
+
+# File includes changes by Thomas Jarosch
+function wait_for_pid()
+{
+ local PID=$1
+ local RET=0
+
+ if [ $PID -eq 0 ] ; then
+ return $RET
+ fi
+
+ # give 60 secs then KILL
+ local COUNTDOWN=60
+
+ while [ -d /proc/${PID} ] && [ $COUNTDOWN -gt 0 ] ; do
+ sleep 1
+ COUNTDOWN=$[$COUNTDOWN-1]
+ done
+
+ if [ -d /proc/${PID} ]; then
+ COMMAND=`ps h -o command ${PID}`
+ logger "dansguardian: timeout waiting for PID ${PID}: ${COMMAND}; sending SIGKILL"
+ kill -KILL $PID >/dev/null 2>&1
+ RET=1
+ fi
+
+ return $RET
+}
+
+# See how we were called.
+
+case "$1" in
+start)
+ if [ -f /usr/sbin/dansguardian ] &&
+ [ -f /etc/dansguardian/dansguardian.conf ]; then
+ echo -n "Starting dansguardian: "
+ if /usr/sbin/dansguardian 2> /dev/null; then
+ echo " OK"
+ else
+ echo " FAILED"
+ fi
+ fi
+ ;;
+stop)
+ echo -n "Shutting down dansguardian: "
+ WAITPID=0
+ if [ -f /var/run/dansguardian.pid ] ; then
+ WAITPID=`cat /var/run/dansguardian.pid`
+ fi
+ if /usr/sbin/dansguardian -q 2> /dev/null; then
+ if wait_for_pid $WAITPID ; then
+ echo " OK"
+ else
+ echo " FAILED"
+ fi
+ /bin/rm -f /var/run/dansguardian.pid
+ /bin/rm -f /tmp/.dguardianipc
+ else
+ echo " FAILED"
+ fi
+ ;;
+restart)
+ $0 stop
+ $0 start
+ ;;
+status)
+ if [ -x /usr/sbin/dansguardian ]; then
+ /usr/sbin/dansguardian -s
+ else
+ echo "Dansguardian is not installed!"
+ fi
+ ;;
+*)
+ echo "Usage: $0 {start|stop|restart|status}" >&2
+ ;;
+esac
+
+exit 0
diff --git a/dansguardian/build/slack-desc b/dansguardian/build/slack-desc
new file mode 100644
index 00000000..b249c6b7
--- /dev/null
+++ b/dansguardian/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+dansguardian: dansguardian (web content filter)
+dansguardian:
+dansguardian: DansGuardian is a web content filter. It filters the actual
+dansguardian: content of pages based on many methods including phrase matching,
+dansguardian: PICS filtering and URL filtering. It does not purely filter
+dansguardian: based on a banned list of sites like lesser totally commercial
+dansguardian: filters. DansGuardian is designed to be completely flexible and
+dansguardian: allows you to tailor the filtering to your exact needs.
+dansguardian:
+dansguardian: dansguardian home: http://dansguardian.org/
+dansguardian: